=== nofib/spectral/Makefile ===
TOP = ..
include $(TOP)/mk/boilerplate.mk

# TODO(michalt): Re-enable `secretary` (requires `random`)
SUBDIRS = ansi atom awards banner boyer boyer2 calendar cichelli circsim \
          clausify constraints cryptarithm1 cryptarithm2 cse dom-lt eliza expert \
          exact-reals fft2 fibheaps fish gcd hartel integer knights lambda \
          last-piece lcss life mandel mandel2 mate minimax multiplier para \
          power pretty primetest puzzle rewrite scc simple sorting sphere \
          treejoin

include $(TOP)/mk/target.mk
