=== libraries/Cabal/doc/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.10
# by the following command:
#
#    pip-compile requirements.in
#
alabaster==0.7.12
    # via sphinx
babel==2.9.1
    # via sphinx
certifi==2022.12.7
    # via
    #   -r requirements.in
    #   requests
charset-normalizer==2.0.7
    # via requests
docutils==0.18.1
    # via
    #   sphinx
    #   sphinx-jsonschema
    #   sphinx-rtd-theme
idna==2.10
    # via requests
imagesize==1.4.1
    # via sphinx
jinja2==3.1.3
    # via
    #   -r requirements.in
    #   sphinx
jsonpointer==2.3
    # via sphinx-jsonschema
markupsafe==2.1.2
    # via jinja2
packaging==23.0
    # via sphinx
pygments==2.14.0
    # via
    #   -r requirements.in
    #   sphinx
pytz==2021.3
    # via babel
pyyaml==6.0.1
    # via sphinx-jsonschema
requests==2.26.0
    # via
    #   sphinx
    #   sphinx-jsonschema
snowballstemmer==2.1.0
    # via sphinx
sphinx==5.3.0
    # via
    #   -r requirements.in
    #   sphinx-rtd-theme
    #   sphinxnotes-strike
sphinx-jsonschema==1.16.11
    # via -r requirements.in
sphinx-rtd-theme==1.2.0
    # via -r requirements.in
sphinxcontrib-applehelp==1.0.2
    # via sphinx
sphinxcontrib-devhelp==1.0.2
    # via sphinx
sphinxcontrib-htmlhelp==2.0.0
    # via sphinx
sphinxcontrib-jquery==2.0.0
    # via sphinx-rtd-theme
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.3
    # via sphinx
sphinxcontrib-serializinghtml==1.1.5
    # via sphinx
sphinxnotes-strike==1.1
    # via -r requirements.in
urllib3==1.26.7
    # via requests

# The following packages are considered to be unsafe in a requirements file:
# setuptools
