=== nofib/imaginary/bernouilli/Makefile ===
TOP = ../..
include $(TOP)/mk/boilerplate.mk

# Override default SRCS; the default is all source files, but
# we don't want to include paraffins.c
SRCS=Main.hs NofibUtils.hs

FAST_OPTS =  60
NORM_OPTS = 180
SLOW_OPTS = 320

include $(TOP)/mk/target.mk
